#include <iostream>
#include <gmpxx.h>
#include <unordered_map>

#include "hash_mpz.h"

using std::cout;
using std::hash;
using std::unordered_map;

int main() {
    mpz_class a;

    mpz_ui_pow_ui(a.get_mpz_t(), 168, 16);

    cout << "a       : " << a << "\n";
    cout << "hash( a): " << (hash<mpz_class> { }(a)) << "\n";
    cout << "hash(-a): " << (hash<mpz_class> { }(-a)) << "\n";

    unordered_map<mpz_class, int> map;
    map[a] = 2;
    cout << "map[a]  : " << map[a] << "\n";
}
